
#include <iostream>
#include <cmath>

#include "glued.hh"
#include "list.hh"
#include "symbol.hh"
#include "mirror.hh"
#include "symbols.hh"
#include "extern.hh"

double testje () { return 1.234; }

struct simple_inst {
  void *rep;
  inline simple_inst (): rep (NULL) {}
  inline simple_inst (void *rep2): rep (rep2) {}
  inline simple_inst (const simple_inst &bb): rep (bb.rep) {}
  inline ~simple_inst () {}
};

template<class T, class F> struct converter {
  static inline T
  helper (F x) {
    return (T) x;
  }
};

template<class T> struct converter<T, simple_inst> {
  static inline T
  helper (simple_inst x) {
    return *((T*) x.rep);
  }
};

template<class F> struct converter<simple_inst, F> {
  static inline simple_inst
  helper (F x) {
    return simple_inst (new F (x));
  }
};

template<class T> struct converter<T&, simple_inst& > {
  static inline T
  &helper (simple_inst &x) {
    return *((T*) x.rep);
  }
};

template<class F> struct converter<simple_inst&, F& > {
  static inline simple_inst
  &helper (F &x) {
    return *new simple_inst (&x);
  }
};

template<class T, class F> inline T
convert (F x) {
  return converter<T, F>::helper (x);
}

template<class T, class F> struct caster {
  static inline T
  helper (F x) {
    return *reinterpret_cast<T* > (&x);
  }
};

template<class T, class F> struct caster<T&, F& > {
  static inline T
  &helper (F &x) {
    return *reinterpret_cast<T* > (&x);
  }
};

template<class T, class F> inline T
cast (F x) {
  return caster<T, F>::helper (x);
}

struct simple_type_rep;
typedef simple_type_rep *simple_type;

struct simple_type_rep {
  inline simple_type_rep () {}
  inline virtual ~simple_type_rep () {}
};

struct simple_int_rep: simple_type_rep {
  inline simple_int_rep (): simple_type_rep () {}
};

simple_type
simple_int () {
  return new simple_int_rep ();
}

struct simple_double_rep: simple_type_rep {
  inline simple_double_rep (): simple_type_rep () {}
};

simple_type
simple_double () {
  return new simple_double_rep ();
}

static mmx::generic ID_1 = mmx::mirror (mmx::symbol ("Int"));
static mmx::generic ID_2 = mmx::mirror (mmx::symbol ("Double"));

static mmx::generic
FUN_3 (mmx::generic g) {
  return mmx::glued<double> (testje ());
}

static mmx::generic
FUN_4 (mmx::generic g) {
  return mmx::glued<double> (-mmx::view_as<double> (g[1]));
}

static mmx::generic
FUN_5 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) + mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_6 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) - mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_7 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) * mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_8 (mmx::generic g) {
  return mmx::glued<double> (mmx::view_as<double> (g[1]) / mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_9 (mmx::generic g) {
  return mmx::glued<double> (pow (mmx::view_as<double> (g[1]), mmx::view_as<int> (g[2])));
}

static mmx::generic
FUN_10 (mmx::generic g) {
  return mmx::glued<double> (pow (mmx::view_as<double> (g[1]), mmx::view_as<double> (g[2])));
}

static mmx::generic
FUN_11 (mmx::generic g) {
  return mmx::glued<double& > (mmx::view_as<double& > (g[1]) += mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_12 (mmx::generic g) {
  return mmx::glued<double& > (mmx::view_as<double& > (g[1]) -= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_13 (mmx::generic g) {
  return mmx::glued<double& > (mmx::view_as<double& > (g[1]) *= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_14 (mmx::generic g) {
  return mmx::glued<double& > (mmx::view_as<double& > (g[1]) /= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_15 (mmx::generic g) {
  return mmx::glued<bool> (mmx::view_as<double> (g[1]) == mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_16 (mmx::generic g) {
  return mmx::glued<bool> (mmx::view_as<double> (g[1]) != mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_17 (mmx::generic g) {
  return mmx::glued<bool> (mmx::view_as<double> (g[1]) < mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_18 (mmx::generic g) {
  return mmx::glued<bool> (mmx::view_as<double> (g[1]) <= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_19 (mmx::generic g) {
  return mmx::glued<bool> (mmx::view_as<double> (g[1]) > mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_20 (mmx::generic g) {
  return mmx::glued<bool> (mmx::view_as<double> (g[1]) >= mmx::view_as<double> (g[2]));
}

static mmx::generic
FUN_21 (mmx::generic g) {
  return mmx::glued<double> (fabs (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_22 (mmx::generic g) {
  return mmx::glued<double> (sqrt (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_23 (mmx::generic g) {
  return mmx::glued<double> (exp (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_24 (mmx::generic g) {
  return mmx::glued<double> (log (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_25 (mmx::generic g) {
  return mmx::glued<double> (sin (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_26 (mmx::generic g) {
  return mmx::glued<double> (cos (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_27 (mmx::generic g) {
  return mmx::glued<double> (tan (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_28 (mmx::generic g) {
  return mmx::glued<double> (sinh (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_29 (mmx::generic g) {
  return mmx::glued<double> (cosh (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_30 (mmx::generic g) {
  return mmx::glued<double> (tanh (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_31 (mmx::generic g) {
  return mmx::glued<double> (asin (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_32 (mmx::generic g) {
  return mmx::glued<double> (acos (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_33 (mmx::generic g) {
  return mmx::glued<double> (atan (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_34 (mmx::generic g) {
  return mmx::glued<double> (atan2 (mmx::view_as<double> (g[1]), mmx::view_as<double> (g[2])));
}

static mmx::generic
FUN_35 (mmx::generic g) {
  return mmx::glued<double> (floor (mmx::view_as<double> (g[1])));
}

static mmx::generic
FUN_36 (mmx::generic g) {
  return mmx::glued<double> (ceil (mmx::view_as<double> (g[1])));
}

namespace mmx { void
initialize_simple () {
  mmx::declare ("Int", ID_1, mmx::ID_CLASS);
  mmx::declare ("Double", ID_2, mmx::ID_CLASS);
  mmx::declare ("testje", FUN_3, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS), ID_2));
  mmx::declare ("-", FUN_4, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("+", FUN_5, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::declare ("-", FUN_6, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::declare ("*", FUN_7, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::declare ("/", FUN_8, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::declare ("^", FUN_9, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_1), ID_2));
  mmx::declare ("^", FUN_10, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::declare ("+=", FUN_11, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_2), ID_2), mmx::list (mmx::ID_ALIAS, ID_2)));
  mmx::declare ("-=", FUN_12, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_2), ID_2), mmx::list (mmx::ID_ALIAS, ID_2)));
  mmx::declare ("*=", FUN_13, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_2), ID_2), mmx::list (mmx::ID_ALIAS, ID_2)));
  mmx::declare ("/=", FUN_14, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, mmx::list (mmx::ID_ALIAS, ID_2), ID_2), mmx::list (mmx::ID_ALIAS, ID_2)));
  mmx::declare ("=", FUN_15, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::declare ("!=", FUN_16, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::declare ("<", FUN_17, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::declare ("<=", FUN_18, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::declare (">", FUN_19, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::declare (">=", FUN_20, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), mmx::ID_BOOL));
  mmx::declare ("abs", FUN_21, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("sqrt", FUN_22, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("exp", FUN_23, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("ln", FUN_24, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("sin", FUN_25, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("cos", FUN_26, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("tan", FUN_27, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("sh", FUN_28, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("ch", FUN_29, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("th", FUN_30, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("arcsin", FUN_31, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("arccos", FUN_32, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("arctan", FUN_33, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("arctan", FUN_34, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2, ID_2), ID_2));
  mmx::declare ("floor", FUN_35, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
  mmx::declare ("ceil", FUN_36, mmx::list (mmx::ID_FUNCTION, mmx::list (mmx::ID_CROSS, ID_2), ID_2));
}
}
